
#ifndef DTC_H_
#define DTC_H_

//#define TESTBENCH

#include "ap_fixed.h"
#include "ap_int.h"
#include "hls_math.h"

#define I 16
#define W 32

#define PI_FIXED ((ap_fixed<W,I>)3.14159265359)

typedef ap_fixed<W, I, AP_TRN, AP_SAT> d_t;

struct inputs
{
	ap_int<I> adc0;
	ap_int<I> adc1;
	ap_int<I> adc2;

	ap_int<I> phi_alpha_r;
	ap_int<I> phi_beta_r;
	ap_int<I> Tem_ref;
	ap_int<I> phi_ref;

	ap_int<I> adc_offset0;
	ap_int<I> adc_offset1;
	ap_int<I> adc_offset2;
	ap_int<I> l;
	ap_int<I> p;
	ap_int<I> epsilon_Tem;
	ap_int<I> epsilon_phi;
};

#ifdef TESTBENCH
struct outputs
{
	d_t debug_phi_s;
	d_t debug_theta_s;
	ap_fixed<64, 32> debug_Tem_s;

	d_t debug_i_alpha;
	d_t debug_i_beta;

	d_t debug_psi_alpha;
	d_t debug_psi_beta;

	ap_uint<1> debug_pwm_0;
	ap_uint<1> debug_pwm_1;
	ap_uint<1> debug_pwm_2;

	ap_uint<2> debug_TemHystState;
	ap_uint<1> debug_PhiHystState;
	ap_uint<3> debug_sector;
};

#endif

#ifdef TESTBENCH
ap_uint<3> dtc(inputs &ins, outputs &outs);
#else
ap_uint<3> dtc(inputs &ins);
#endif

#endif
